#include "ConfigData.h"
#include <direct.h>
#include <string.h>
#include <malloc.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

static ConfigData data;

int BrowseDir();

ConfigData * GetConfigData()
{
	return &data;
}

void WriteConfig()
{
	char curDir[1024];
	FILE *fp = fopen("messiahC4D.cfg", "w");

	_getcwd(curDir, 1024);

	if( !fp )
	{
		return;
	}

	fprintf(fp, "MESSIAHPATH = %s\n", data.messiahPath);
	fprintf(fp, "SCALEFACTOR = %f\n", data.scaleFactor);
	
	fclose(fp);
	
}

ConfigData * ReadConfig()
{
	FILE *fp = fopen("messiahC4D.cfg", "r");
	char curDir[1024];
	char line[2048];

	data.scaleFactor = 1.0;
	
	_getcwd(curDir, 1024);

	if(!fp)
	{
		if( BrowseDir() )
		{
			return &data;
		}
		return 0;
	}

	fgets(line, sizeof(line), fp);
	
	while( 1 )
	{

		if( strncmp(line, "MESSIAHPATH = ", 14) == 0 )
		{
			strcpy(data.messiahPath, line + 14);
			if(data.messiahPath[strlen(data.messiahPath)-1] == '\n')
				data.messiahPath[strlen(data.messiahPath)-1] = '\0';
		}

		if( strncmp(line, "SCALEFACTOR = ", 14) == 0 )
			data.scaleFactor = (float)atof(line + 14);

		fgets(line, sizeof(line), fp);
		if( feof(fp) ) break;
	}

	fclose(fp);

	return &data;
}

int BrowseDir()
{
	char d_directory[MAX_PATH];
	OPENFILENAME ofn;

	_getcwd(d_directory, MAX_PATH);

	strcpy(data.messiahPath, "messiahStudio.exe");


	ofn.lStructSize       = sizeof (OPENFILENAME) ;
	ofn.hwndOwner         = NULL ;
	ofn.hInstance         = NULL ;
	ofn.lpstrFilter       = NULL;
	ofn.lpstrCustomFilter = NULL ;
	ofn.nMaxCustFilter    = 0 ;
	ofn.nFilterIndex      = 0 ;
	ofn.lpstrFile         = data.messiahPath ;    
	ofn.nMaxFile          = MESSIAH_PATH_LENGTH ;
	ofn.lpstrFileTitle    = NULL ;          
	ofn.nMaxFileTitle     = 0 ;
	ofn.lpstrInitialDir   = d_directory ;
	ofn.lpstrTitle        = "Locate your messiah executable" ;
	ofn.Flags             = 0 ;             
	ofn.nFileOffset       = 0 ;
	ofn.nFileExtension    = 0 ;
	ofn.lpstrDefExt       ="exe" ;
	ofn.lCustData         = 0L ;
	ofn.lpfnHook          = NULL ;
	ofn.lpTemplateName    = NULL ;

	if( GetOpenFileName(&ofn) )
	{
		data.messiahPath[ofn.nFileOffset - 1] = '\0';

		return TRUE;
	}

	return FALSE;
}