#ifndef MESSIAH_C4D_CLASSES
#define MESSIAH_C4D_CLASSES


#include <c4d.h>
#include <c4d_symbols.h>
#include "messiahC4Dconstants.h"

////////////////////////////////////////////////////////////////////////////
/*
			messiahDeformer
*/
////////////////////////////////////////////////////////////////////////////
class messiahDeformer : public ObjectData
{
public:

	messiahDeformer();	// will startup messiah if not already active
	
	Bool				ModifyObject(PluginObject* mod, BaseDocument* doc, BaseObject* op, 
									 const Matrix& op_mg, const Matrix& mod_mg, Real lod, 
									 LONG flags, BaseThread* thread);

	void				CheckDirty(PluginObject *op, BaseDocument *doc );

	Bool				Write(GeListNode *node, HyperFile *hf);
	Bool				Read(GeListNode* node, HyperFile* hf, LONG level);
	
	static	NodeData *	Alloc(void) { return gNew messiahDeformer; }

	//void				Free( GeListNode *node );

private:
	BaseTime	lastTime;
};

////////////////////////////////////////////////////////////////////////////
/*
			messiahMover
*/
////////////////////////////////////////////////////////////////////////////
class messiahMover : public TagData
{
public:

	messiahMover();

	LONG				Execute(PluginTag* tag, BaseDocument* doc, BaseObject* op, BaseThread* bt, LONG priority, LONG flags);

	Bool				Write(GeListNode *node, HyperFile *hf);
	Bool				Read(GeListNode* node, HyperFile* hf, LONG level);

	static NodeData *	Alloc(void) { return gNew messiahMover; }
};

////////////////////////////////////////////////////////////////////////////
/*
			messiahDformTag
*/
////////////////////////////////////////////////////////////////////////////
class messiahDformTag : public TagData 
{
public:

	Bool				Init( GeListNode *node );
	void				Free( GeListNode *node );
	
	Bool				Write(GeListNode *node, HyperFile *hf);
	Bool				Read(GeListNode* node, HyperFile* hf, LONG level);

	static NodeData *	Alloc(void) { return gNew messiahDformTag; }

	int id;
};

////////////////////////////////////////////////////////////////////////////
/*
			messiahDialog
*/
////////////////////////////////////////////////////////////////////////////
class messiahDialog : public GeDialog
{
public:

	Bool CreateLayout(void);
	Bool InitValues(void);
	Bool Command( LONG id, const BaseContainer &msg );

};

////////////////////////////////////////////////////////////////////////////
/*
			messiahCommand
*/
////////////////////////////////////////////////////////////////////////////
class messiahCommand : public CommandData
{
public:

	Bool RestoreLayout(void *secret);
	Bool Execute( BaseDocument *doc );

private:
	messiahDialog dialog;

};


#endif