#include "messiahC4Dclasses.h"

#define MHLIB_ALL
#include <mhlib/mhlib.h>

// old config file code, temporary
#include "ConfigData.h"

// Globals	/////////////////////////////////////////////////////////////////////////////////////////////////

extern mh::module *		messiahHost;
extern char				progName[];
extern char				plugName[];
extern ConfigData *		config;
extern bool				messiah_loaded;

extern void	messagebox (char const *msg );

// Load Dialog Layout from messiahDial.res (::CreateLayout)  //////////////////////////////////////////////////////////////////////////

Bool messiahDialog::CreateLayout()
{
	Bool res = GeDialog::CreateLayout();

	res = LoadDialogResource(MESSIAHDIAL,NULL,0);

	return res;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Initialize Control's values (::InitValues)  //////////////////////////////////////////////////////////////////////////

Bool messiahDialog::InitValues(void)
{
	this->Enable( GUI_LAUNCH_MESSIAH_ID, TRUE );
	this->Enable( GUI_KILL_MESSIAH_ID, FALSE );
	this->Enable( SCALE_FACTOR, TRUE );
	this->Enable( GUI_SCALE_FACTOR_ID, TRUE );
	this->Enable( PATH_TO_MESSIAH, FALSE );
	this->Enable( GUI_MESSIAH_PATH_ID, TRUE );
	this->Enable( GUI_BUTTON_FILE_ID, TRUE );

	this->SetReal( GadgetPtr( GUI_SCALE_FACTOR_ID ), config->scaleFactor, 0.001, 1000.0, 0.01 );
	this->SetString( GadgetPtr( GUI_MESSIAH_PATH_ID ), String( config->messiahPath ) );

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Respond to Control Notifications (::Command)  //////////////////////////////////////////////////////////////////////////

Bool messiahDialog::Command( LONG id, const BaseContainer &msg )
{
	switch( id )
	{

	case GUI_MESSIAH_PATH_ID:
		{
			String path;

			this->GetString( GadgetPtr( GUI_MESSIAH_PATH_ID ), path );

			path.GetCString( config->messiahPath, MESSIAH_PATH_LENGTH );
		}
		break;

	case GUI_BUTTON_FILE_ID:
		{
			BrowseDir();
			this->SetString( GadgetPtr( GUI_MESSIAH_PATH_ID ), String( config->messiahPath ) );

			messagebox( "messiah path changed.\nYou must restart Cinema 4D for these changes to take effect." );
		}
		break;

	case GUI_SCALE_FACTOR_ID:
		{
			Real scale = 1.0;

			this->GetReal( GadgetPtr( GUI_SCALE_FACTOR_ID ), scale );

			config->scaleFactor = scale;
		}
		break;

	case GUI_LAUNCH_MESSIAH_ID:
		{
			if( !messiah_loaded ) return FALSE;

			// If messiah is not already loaded...
			if( !messiahHost->isMessiahActive() )
			{
				SetString( GUI_STATUS_ID, "Status: messiah loading... please wait" );
				messiahHost->startup( progName, plugName );
			}

			SetString( GUI_STATUS_ID, "Status: messiah loaded" );

			messiahHost->showInterface();

			SetString( GUI_LAUNCH_MESSIAH_ID, "Switch To messiah" );
		}
		break;

	case GUI_PROJECTMESSIAH_ID:
		{
			GeOpenHTML( "www.projectmessiah.com" );
		}
		break;

	}

	return TRUE;
}
////////////////////////////////////////////////////////////////////////////////////////////////////////////////

