/**********************************************************************
 *<
	FILE: messiahMAX.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2000, All Rights Reserved.
 **********************************************************************/


#ifdef MESSIAH_MAX_VERSION_8
#define HOST_MODULE_NAME	"messiahMAX8x.dlm" //Dan 11-27-03
#else
	#ifdef MESSIAH_MAX_VERSION_6
	#define HOST_MODULE_NAME	"messiahMAX6x.dlm" //Dan 11-27-03
	#else
		#ifdef MESSIAH_MAX_VERSION_5 //Dan 3-28-03
		#define HOST_MODULE_NAME	"messiahMAX5x.dlm"
		#else
		#define HOST_MODULE_NAME	"messiahMAX4x.dlm"
		#endif
	#endif
#endif


#define HOST_APP_NAME		"3dsmax"

#include "messiahMAXclassDefs.h"

#include "plugapi.h"

// ===============================================================
// Global Variables
// ===============================================================

static Matrix3	mat, mat_inv;	// not currently used
HINSTANCE		messiahlib		= NULL;

// Global State Flags ///////////////////////////////
int				loading_MAX_scene	= 0;
int				saving_MAX_scene	= 0;
int				merging_MAX_scene	= 0;
int				reseting_MAX_scene	= 0;
int				newing_MAX_scene	= 0;
int				load_messiah_scene	= 0;
int				save_messiah_scene	= 0;
/////////////////////////////////////////////////////

// Globals, use: ? //////////////////////////////////
int				actual_num_modifiers	= 0;
int				scene_exists			= 0;
int				ref_counter				= 0;
/////////////////////////////////////////////////////

// File IO Globals //////////////////////////////////
static manager		plugMan;
static int			num_saved = 0;

static messiahMAX	**loaded_ref_pointers	= NULL;
static int			num_loaded_refs			= 0;

static messiahMAX	**saved_ref_pointers	= NULL;
static int			num_saved_refs			= 0;

static int			num_presave_refs		= 0;

static messiahMAX	**master_ref_pointers	= NULL;
static int			num_master_refs			= 0;
/////////////////////////////////////////////////////

// Instance of the messiahMAXClassDesc class and a global to retrieve it ///////////////
static		messiahMAXClassDesc messiahMAXDesc;
ClassDesc2* GetmessiahMAXDesc() { return &messiahMAXDesc; }
////////////////////////////////////////////////////////////////////////////////////////

// Instance of the messiahMAXcontrollerClassDesc class and a global to retrieve it /////
static		messiahMAXcontrollerClassDesc messiahMAXctrlDesc;
ClassDesc2* GetmessiahMAXcontrollerDesc() { return &messiahMAXctrlDesc; }
////////////////////////////////////////////////////////////////////////////////////////

// Instance of the messiahMAXUtilClassDesc class and a global to retrieve it /////
static		messiahMAXUtilClassDesc messiahMAXutilDesc;
ClassDesc*	GetmessiahMAXUtilClassDesc() { return &messiahMAXutilDesc; }
////////////////////////////////////////////////////////////////////////////////////////

// Instance of the messiahDialogHook class /////////////////////////////////////////////
static		messiahDialogHook	DialogProc;
////////////////////////////////////////////////////////////////////////////////////////

// Instance of the messiahDialogHook class /////////////////////////////////////////////
static		enumMCs				EnumMC;
////////////////////////////////////////////////////////////////////////////////////////

// ===============================================================
// Static Data Member Initialization
// ===============================================================

// messiahMAX ///////////////////////////////////////////////////////////////////////////
IObjParam *messiahMAX::ip			= NULL;
/////////////////////////////////////////////////////////////////////////////////////////



// ===============================================================
// messiahMAX Implementation
// ===============================================================

// Constructor ///////////////////////////////////////////////////////////////////////////
messiahMAX::messiahMAX() : managerElmt(MMAX_DFORMER), loaded(false)
{
	messiahMAXDesc.MakeAutoParamBlocks(this);
	ref_counter++;
	// section removed, see removedFromMessiahMax.cpp
}//////////////////////////////////////////////////////////////////////////////////////////

// Destructor ////////////////////////////////////////////////////////////////////////////
messiahMAX::~messiahMAX()
{
	manager::plugIter it = plugMan.plugins.begin();

	while( it != plugMan.plugins.end() )
	{
		if(*it == this)
		{
			plugMan.plugins.erase(it);
			return;
		}

		it++;
	}

	// section removed, see removedFromMessiahMax.cpp
	ref_counter--;
}//////////////////////////////////////////////////////////////////////////////////////////

// LocalValidity /////////////////////////////////////////////////////////////////////////
Interval messiahMAX::LocalValidity(TimeValue t)
{
//	if (TestAFlag(A_MOD_BEING_EDITED))
//		return NEVER;  
	return NEVER;
}///////////////////////////////////////////////////////////////////////////////////////////

// NotifyPreCollapse //////////////////////////////////////////////////////////////////////
void messiahMAX::NotifyPreCollapse(INode *node, IDerivedObject *derObj, int index)
{
	//TODO:  Perform any Pre Stack Collapse methods here
}///////////////////////////////////////////////////////////////////////////////////////////

// NotifyPostCollapse /////////////////////////////////////////////////////////////////////
void messiahMAX::NotifyPostCollapse(INode *node,Object *obj, IDerivedObject *derObj, int index)
{
	//TODO: Perform any Post Stack collapse methods here.
}///////////////////////////////////////////////////////////////////////////////////////////

// ModifyObject ///////////////////////////////////////////////////////////////////////////
void messiahMAX::ModifyObject(TimeValue t, ModContext &mc, ObjectState * os, INode *node) 
{
	// add the plug to the list if it's not already on it
	if( !this->onList )
	{
		if( loading_MAX_scene || merging_MAX_scene )
			plugMan.loadingList.push_back(this);
		else
			plugMan.plugins.push_back(this);

		this->onList = true;
	}

	// make sure we only get called once when loading
	if(this->loaded && (loading_MAX_scene||merging_MAX_scene) )
		return;

	messiahData		*m_data=NULL;
	Object			*obj = os->obj;
	int				i, num_faces, ticks_per_frame = GetTicksPerFrame(), num_points;
	double			point[3];
	Point3			vert;
	Interval		valid = FOREVER;

	messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

	valid.SetInstant(t);

	// once only. create local data, create node logs, set load ids, free temp lists, set as loaded
	if( loading_MAX_scene || merging_MAX_scene )
	{
		os->obj->UpdateValidity(GEOM_CHAN_NUM, valid);

		plugMan.tmpMClist.clear();
		this->EnumModContexts(&EnumMC);

		manager::mcIter mcIt = plugMan.tmpMClist.begin();

		// foreach mod context
		while( mcIt != plugMan.tmpMClist.end() )
		{
			// create local data
			 m_data= new messiahData;
			 (*mcIt)->localData = m_data;

			INode *n = FindNodeReference(this, *mcIt);
			if(!n)
				continue;
			
			Object *o = n->GetObjectRef();
			if(!o)
				continue;

			int index = this->getIndex(o);
			if(index == -1)
				continue;

			// now that we have the Object and the loadID we'll create the log
			FX_NodeLog *log = NULL;

			log = nodeLogElement( (void *)this, (void *)o, (void *)*mcIt, NULL);
			if(!log)
				continue;
			log->type = MMAX_DFORMER;

			// since we're loading set the load ID
			log->load_ID = this->loadIds[index];
			m_data->loadID = log->ID; //log->load_ID;
			m_data->loaded = true;

			/////////////////////// DEBUG /////////////////////////////////
			///////////////////////////////////////////////////////////////
			INode *node = FindNodeReference(this, &mc);
			char * maxname = node->GetName();
			///////////////////////////////////////////////////////////////

			mcIt++;
		}

		this->loaded = true;
		delete [] this->objs;
		delete [] this->loadIds;

		return;
	}

	// set m_data from mod context
	if( !(m_data = (messiahData *)(mc.localData)) )
	{
		// we should only get here when a new connection is being made, not loaded
		m_data = new messiahData;
		mc.localData = m_data;
	}

/*	// only once. imediatly after loading. set the messiah object for the mod context
	if( !m_data->messiah_object && m_data->loaded )
	{
		m_data->messiah_object = plugMan.GetObjFromIndex(m_data->loadID);

		/////////////////////// DEBUG /////////////////////////////////
		///////////////////////////////////////////////////////////////
		char mobjname[512];
		nodeObjectNameGet( m_data->messiah_object, mobjname, 512);
		INode *node = FindNodeReference(this, &mc);
		char * maxname = node->GetName();
		///////////////////////////////////////////////////////////////

	}
*/	// otherwise it's a newly created connection not loaded from disk
	// else
	if( !m_data->messiah_object && !m_data->loaded )
	{
		INode *node = FindNodeReference(this, &mc);
		Object *object = node->GetObjectRef();
		FX_NodeLog *log = NULL;

		log = nodeLogElement( (void *)this, (void *)obj, (void *)&mc, NULL);
		log->type = MMAX_DFORMER;

		m_data->messiah_object = nodeObjectCreate(node->GetName(), 0, 0);
		log->obj = m_data->messiah_object;
		
		genericGeometryCopy(node, m_data->messiah_object, 1, obj);
	}

	//whew, if we've made it here then we have all the info we need to displace the item

	if (obj->IsSubClassOf(polyObjectClassID))
	{
		PolyObject	*pobj = (PolyObject *)obj;
		MNMesh		&mnmesh = pobj->GetMesh();
		MNVert *	mnvert = NULL;

		num_points = mnmesh.numv;
		num_faces = mnmesh.numf;

		if( m_data = (messiahData*)mc.localData)
		{
			messiahCheckTime(((double)t/(double)ticks_per_frame), 1);

			for( i = 0; i < num_points; i++)
			{
				mnvert = mnmesh.V(i);	// get MNVert pointer
				nodeObjectGetPoint(m_data->messiah_object, i, &point[0], &point[1], &point[2]);
				mnvert->p[0] = (float)point[0] / ::theUtilityObj.d_scaleFactor;
				mnvert->p[1] = (float)point[2] / ::theUtilityObj.d_scaleFactor;
				mnvert->p[2] = (float)point[1] / ::theUtilityObj.d_scaleFactor;
			}
		}// if messiahData
	}// PolyObject
	else if (obj->IsSubClassOf(triObjectClassID))
	{
		TriObject	*tobj = (TriObject*)obj;
		Mesh		&mesh = tobj->GetMesh();

		num_points = mesh.numVerts;
		num_faces = mesh.numFaces;

		if (m_data = (messiahData*)mc.localData)
		{
			messiahCheckTime(((double)t/(double)ticks_per_frame), 1);

			for (i=0; i<num_points; i++)
			{
				/////////////////////// DEBUG /////////////////////////////////
				///////////////////////////////////////////////////////////////
				char mobjname[512];
				nodeObjectNameGet( m_data->messiah_object, mobjname, 512);
				INode *node = FindNodeReference(this, &mc);
				char * maxname = node->GetName();
				///////////////////////////////////////////////////////////////

				nodeObjectGetPoint(m_data->messiah_object, i, &point[0], &point[1], &point[2]);
				vert.x = (float)point[0] / ::theUtilityObj.d_scaleFactor;
				vert.y = (float)point[2] / ::theUtilityObj.d_scaleFactor;
				vert.z = (float)point[1] / ::theUtilityObj.d_scaleFactor;
				//vert = vert * mat_inv;
				obj->SetPoint(i, vert);
			}
		}
	}// TriObject

	NotifyDependents(valid, GEOM_CHANNEL, REFMSG_CHANGE);
	os->obj->UpdateValidity(GEOM_CHAN_NUM, valid);
	os->obj->PointsWereChanged();

	return;
}////////////////////////////////////////////////////////////////////////////////////////////////

// BeginEditParams /////////////////////////////////////////////////////////////////////////////
void messiahMAX::BeginEditParams( IObjParam *ip, ULONG flags,Animatable *prev )
{
	this->ip = ip;
	messiahMAXDesc.BeginEditParams(ip, this, flags, prev);

	messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

	//messiahInterface();
}////////////////////////////////////////////////////////////////////////////////////////////////

// EndEditParams ////////////////////////////////////////////////////////////////////////////////
void messiahMAX::EndEditParams( IObjParam *ip, ULONG flags,Animatable *next)
{
	messiahMAXDesc.EndEditParams(ip, this, flags, next);
	this->ip = NULL;
}////////////////////////////////////////////////////////////////////////////////////////////////

// Clone ////////////////////////////////////////////////////////////////////////////////////////
RefTargetHandle messiahMAX::Clone(RemapDir& remap)
{
	messiahMAX* newmod = new messiahMAX();	
	
	newmod->ReplaceReference(PBLOCK_REF,pblock->Clone(remap));
	BaseClone(this, newmod, remap);
	return(newmod);
}/////////////////////////////////////////////////////////////////////////////////////////////////

// NotifyRefChanged //////////////////////////////////////////////////////////////////////////////
RefResult messiahMAX::NotifyRefChanged(
		Interval changeInt, RefTargetHandle hTarget,
		PartID& partID,  RefMessage message) 
{
	// removed section, see removedFromMessiahMax.cpp
	return REF_SUCCEED;
}//////////////////////////////////////////////////////////////////////////////////////////////////

// NotifyInputChanged /////////////////////////////////////////////////////////////////////////////
void messiahMAX::NotifyInputChanged(Interval changeInt, PartID partID, RefMessage message, ModContext *mc)
{
// 	NotifyInputChanged is called each time the input object is changed in some way
 //	We can find out how it was changed by checking partID and message

	messiahData		*m_data=NULL;
	int i;

	if (!mc || (!(m_data = (messiahData*)mc->localData))) return;

	if (message==REFMSG_CHANGE)
	{
		if (partID & PART_TOPO) //rebuild the object
		{
			nodeObjectRebuild(m_data->messiah_object, 0);
		}
		else if (partID&PART_GEOM) //reset the object and its points
		{
			i = 0;
		}
		else if (partID&PART_MTL)
		{
			i = 0;
		}
	}
	else if (message==REFMSG_NODE_NAMECHANGE)
	{
		i = 0;
	}
	else if (message==REFMSG_TARGET_DELETED)
	{
		i = 0;
	}

}///////////////////////////////////////////////////////////////////////////////////////////////////

// SetGenUVW ///////////////////////////////////////////////////////////////////////////////////////
void messiahMAX::SetGenUVW(BOOL sw) 
{  
	if (sw==HasUVW()) return;
}///////////////////////////////////////////////////////////////////////////////////////////////////

// Load ////////////////////////////////////////////////////////////////////////////////////////////
IOResult messiahMAX::Load(ILoad *iload)
{

	Modifier::Load(iload);

	if (!loaded_ref_pointers)
	{
		loaded_ref_pointers = (messiahMAX**)calloc(1,sizeof(messiahMAX*));
	}
	else
	{
		loaded_ref_pointers = (messiahMAX**)realloc(loaded_ref_pointers,(num_loaded_refs+1)*sizeof(messiahMAX*));
	}

	loaded_ref_pointers[num_loaded_refs++]=this;

	char		*buff=NULL;
	ULONG		nb;
	IOResult	res;
	int			l=0;
	int			num_refs = 0;
	int			tmp = 0;

	while (IO_OK==(res=iload->OpenChunk()))
	{
		switch(iload->CurChunkID())
		{
			case FILE_SIZE_CHUNK:
				res=iload->Read(&l, sizeof(int), &nb);
				break;

			case FILE_BUFF_CHUNK:
				res=iload->ReadCStringChunk(&buff);
				if (buff)
				{
					messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

					scene_exists = messiahSceneFileLoadBuff(buff);
				}
				break;

			case FILE_NUM_NODE_REFS:
				res=iload->Read(&num_refs, sizeof(int), &nb);
				break;

			case FILE_NODE_REFS:
				this->loadIds = new int[num_refs];
				this->objs = new Object *[num_refs];

				for(int i = 0; i < num_refs; i++)
				{	
					Object *obj = NULL;
					res=iload->Read(&tmp, sizeof(int), &nb);
					iload->RecordBackpatch(tmp, (void **)(&this->objs[i]) );

					tmp = 0;
					res=iload->Read(&tmp, sizeof(int), &nb);
					this->loadIds[i] = tmp;
				}
				
				this->numObjs = num_refs;

		}
		iload->CloseChunk();
	}

	return IO_OK;
}////////////////////////////////////////////////////////////////////////////////////////////////////

// Save /////////////////////////////////////////////////////////////////////////////////////////////
IOResult messiahMAX::Save(ISave *isave)
{
	num_saved++;

	Modifier::Save(isave);

	ULONG		nb;

	plugMan.tmpMClist.clear();
	this->EnumModContexts(&EnumMC);

	int	num_refs = plugMan.tmpMClist.size();

	isave->BeginChunk(FILE_NUM_NODE_REFS);
	isave->Write(&num_refs, sizeof(int), &nb);
	isave->EndChunk();

	// write the references
	isave->BeginChunk(FILE_NODE_REFS);

	manager::mcIter	it = plugMan.tmpMClist.begin();
	while( it != plugMan.tmpMClist.end() )
	{	
		INode * node = FindNodeReference(this, *it);
		if( !node )
			continue;

		Object *object = node->GetObjectRef();
		if( !object )
			continue;

		/////////////////////// DEBUG /////////////////////////////////
		///////////////////////////////////////////////////////////////
		char mobjname[512];
		nodeObjectNameGet( ((messiahData*)((*it)->localData))->messiah_object, mobjname, 512);
		char * maxname = node->GetName();
		///////////////////////////////////////////////////////////////

		int RefID = isave->GetRefID( object );
//		FX_NodeLog *log = plugMan.GetNodeLog( ((messiahData *)(*it))->messiah_object);
		FX_NodeLog *log = plugMan.GetNodeLog( ((messiahData*)((*it)->localData))->messiah_object);
		if(!log)
			return IO_ERROR;

		int	LoadID = log->ID;

		isave->Write(&RefID, sizeof(int), &nb);
		isave->Write(&LoadID, sizeof(int), &nb);

		it++;
	}

	isave->EndChunk();
	
	int num_plugs = plugMan.plugins.size();

	if (num_saved == num_plugs )
	{
		char	*buff = messiahSceneFileCreateBuff();
		ULONG	nb;
		int		l;

		if (!buff) return IO_OK;
		l = strlen(buff);

	 	isave->BeginChunk(FILE_SIZE_CHUNK);
		isave->Write(&l, sizeof(int), &nb);
		isave->EndChunk();

	 	isave->BeginChunk(FILE_BUFF_CHUNK);
		isave->WriteCString(buff);
		isave->EndChunk();


		messiahSceneFileClearBuff(buff);
	}

	return IO_OK;
}////////////////////////////////////////////////////////////////////////////////////////////////////

messiahMAXcontroller::messiahMAXcontroller() : managerElmt(MMAX_XFORMER)
{
	messiahMAXctrlDesc.MakeAutoParamBlocks(this);
}

messiahMAXcontroller::~messiahMAXcontroller()
{
	manager::plugIter it = plugMan.plugins.begin();

	while( it != plugMan.plugins.end() )
	{
		if(*it == this)
		{
			plugMan.plugins.erase(it);
			return;
		}

		it++;
	}
}

void messiahMAXcontroller::GetValue(TimeValue t, void *val, Interval &valid, GetSetMethod method)
{

	// add the plug to the list if it's not already on it
	if( !this->onList )
	{
		if( loading_MAX_scene || merging_MAX_scene )
			plugMan.loadingList.push_back(this);
		else
			plugMan.plugins.push_back(this);

		this->onList = true;
	}

	StdControl::GetValue(t, val, valid, method);

	Matrix3 *	mat = (Matrix3 *)val;		// Transform Matrix to set
	Matrix3		tm;
	int ticks_per_frame = GetTicksPerFrame();
	double time = (double)t/(double)ticks_per_frame;

	valid = NEVER;

	if(!mat)
		return;

	messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

	
	// for some reason this func gets called multiple times while the scene is loading
	// make sure we only add the item once
	if( loading_MAX_scene && this->messiah_data.loaded )
		return;

	// if no messiah object, but loaded flag is set then this item was loaded from disk
	// but hasn't had it's messiah object set yet, we'll retrieve it based on it's load id
	// and assign it now.

	if( ! this->messiah_data.messiah_object && this->messiah_data.loaded )
		this->messiah_data.messiah_object = plugMan.GetObjFromIndex( this->messiah_data.loadID );

	if( ! this->messiah_data.messiah_object )
	{		
		// find the node that references this controller and add it to messiah
		DependentIterator		di( this );
		ReferenceMaker *		rm;

		while( rm = di.Next() )
		{
			if( rm->SuperClassID() == BASENODE_CLASS_ID )
			{
				INode *node = ( INode * ) rm;
				Object *object = node->GetObjectRef();
				FX_NodeLog *log = NULL;

				// node log
				log = nodeLogElement( NULL, object, (void *)node, NULL);
				log->type = MMAX_XFORMER;

				if( !loading_MAX_scene && !merging_MAX_scene )
				{
					this->messiah_data.messiah_object = nodeObjectCreate(node->GetName(), 0, 0);

					log->obj = this->messiah_data.messiah_object;

					// geometry copy
					genericGeometryCopy(node, this->messiah_data.messiah_object, 1);
				}
				else
				{
					log->load_ID = this->messiah_data.loadID;
					this->messiah_data.loaded = true;
				}


				break;

			}// if BASENODE_CLASS_ID
		}// while iterator
	}// if messiah_obj
	else
	{
		Point3		trans, rot, scale;
		double		group[3]; // trans, rot, or scale from messiah
		
		messiahCheckTime( time, 1 );

		nodeObjectGetWorldPos( this->messiah_data.messiah_object, group, time);
		trans[0] = (float)group[0] * 100.0f;
		trans[1] = (float)group[2] * 100.0f;
		trans[2] = (float)group[1] * 100.0f;

		nodeObjectGetWorldRot( this->messiah_data.messiah_object, group, time);
		rot[0] = -(float)group[1];	// swap for HPB -> XYZ
		rot[1] = -(float)group[0];
		rot[2] = -(float)group[2];

		tm.IdentityMatrix();
		tm.SetTrans(trans);
		tm.RotateY( rot[2] );		// swap Y for Z for Zup conversion
		tm.RotateX( rot[0] );
		tm.RotateZ( rot[1] );

		*mat = tm;

	}// else do the transformation

}

void messiahMAXcontroller::BeginEditParams(IObjParam *ip, ULONG flags, Animatable *prev)
{
	messiahMAXctrlDesc.BeginEditParams(ip, this, flags, prev);
}

void messiahMAXcontroller::EndEditParams(IObjParam *ip, ULONG flags, Animatable *next)
{
	messiahMAXctrlDesc.EndEditParams(ip, this, flags, next);
}

IOResult	messiahMAXcontroller::Save(ISave *isave)
{
	FX_NodeLog *log = plugMan.GetNodeLog(this->messiah_data.messiah_object);
	ULONG		nb;
	Control::Save(isave);

	if( log )
	{
		isave->BeginChunk(FILE_NODE_ID);
		isave->Write(&log->ID, sizeof(int), &nb);
		isave->EndChunk();
	}

	num_saved++;

	if( num_saved == plugMan.plugins.size() ) // if last plug to save
	{
		char	*buff = messiahSceneFileCreateBuff();
		ULONG	nb;
		int		l;

		if (!buff) return IO_OK;
		l = strlen(buff);

	 	isave->BeginChunk(FILE_SIZE_CHUNK);
		isave->Write(&l, sizeof(int), &nb);
		isave->EndChunk();

	 	isave->BeginChunk(FILE_BUFF_CHUNK);
		isave->WriteCString(buff);
		isave->EndChunk();

		messiahSceneFileClearBuff(buff);
	}
	
	return IO_OK;
}

IOResult	messiahMAXcontroller::Load(ILoad *iload)
{
	Control::Load(iload);

	char		*buff=NULL;
	ULONG		nb;
	IOResult	res;
	int			l=0;

	while (IO_OK==(res=iload->OpenChunk()))
	{
		switch(iload->CurChunkID())
		{
			case FILE_NODE_ID:
				res=iload->Read(&this->messiah_data.loadID, sizeof(int), &nb);
				break;

			case FILE_SIZE_CHUNK:
				res=iload->Read(&l, sizeof(int), &nb);
				break;

			case FILE_BUFF_CHUNK:
				res=iload->ReadCStringChunk(&buff);
				if (buff)
				{
					messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

					scene_exists = messiahSceneFileLoadBuff(buff);
				}
				break;
		}
		iload->CloseChunk();
	}


	return IO_OK;
}

// ===============================================================
// messiahMAXClassDesc Implementation
// ===============================================================

//	BeginCreate		/////////////////////////////////////////////////////////////////////
int messiahMAXClassDesc::BeginCreate(Interface *i)
{	
	return FALSE;
}/////////////////////////////////////////////////////////////////////////////////////////

//	EndCreate		/////////////////////////////////////////////////////////////////////
int messiahMAXClassDesc::EndCreate(Interface *i)
{
	
	return FALSE;
}/////////////////////////////////////////////////////////////////////////////////////////

//	Create		/////////////////////////////////////////////////////////////////////////
void *messiahMAXClassDesc::Create(BOOL loading)
{
	if( !merging_MAX_scene )
		loading_MAX_scene = loading;

	messiahMAX *m = new messiahMAX();
	
/*	if(loading)
		plugMan.loadingList.push_back(m);
	else
	{
		plugMan.plugins.push_back(m);
		MessageBox(NULL, "Modifier Created", NULL, 0);
	}
*/
	return  m;
}/////////////////////////////////////////////////////////////////////////////////////////



// ===============================================================
// messiahMAXcontrollerClassDesc Implementation
// ===============================================================

//	BeginCreate		/////////////////////////////////////////////////////////////////////
int messiahMAXcontrollerClassDesc::BeginCreate(Interface *i)
{	
	return FALSE;
}/////////////////////////////////////////////////////////////////////////////////////////

//	EndCreate		/////////////////////////////////////////////////////////////////////
int messiahMAXcontrollerClassDesc::EndCreate(Interface *i)
{
	
	return FALSE;
}/////////////////////////////////////////////////////////////////////////////////////////

//	Create		/////////////////////////////////////////////////////////////////////////
void *messiahMAXcontrollerClassDesc::Create(BOOL loading)
{
	loading_MAX_scene = loading;
	messiahMAXcontroller *c = new messiahMAXcontroller(); 

/*	if(loading)
		plugMan.loadingList.push_back(c);
	else
	{
		plugMan.plugins.push_back(c);
		MessageBox(NULL, "Controller Created", NULL, 0);
	}
*/
	return c;
}/////////////////////////////////////////////////////////////////////////////////////////



// ===============================================================
// messiahData Implementation
// ===============================================================

//	Clone	//////////////////////////////////////////////////////////////////////////////
LocalModData *		messiahData::Clone ()
{	messiahData *clone;
	clone = new messiahData ();
	clone->messiah_object = this->messiah_object;
	
	return(clone);
}/////////////////////////////////////////////////////////////////////////////////////////


// ===============================================================
// enumMCs Implementation
// ===============================================================

// Proc ///////////////////////////////////////////////////////////////////////////////////
BOOL enumMCs::proc(ModContext *mc)
{
	if( !mc ) return TRUE;

	plugMan.tmpMClist.push_back( mc );

	return TRUE;
}

// ===============================================================
// messiahDialogHook Implementation
// ===============================================================

//	DialogProc	//////////////////////////////////////////////////////////////////////////
BOOL	messiahDialogHook::DlgProc(TimeValue t, IParamMap2 *map, HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch( msg )
	{
	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case IDC_LAUNCH:
			messiahInterface();
			break;

		case IDC_ABOUT:
			MessageBox(NULL, "messiah:animate\n\ncopyright 1998-2002\nDan Milling, Lyle Milton\nand Fori Owurowa", "About", 0);
			break;

		}
		break;
	}

	return FALSE;
}//////////////////////////////////////////////////////////////////////////////////////////

// ===============================================================
// messiahMAXUtilDlgProc Implementation
// ===============================================================
static INT_PTR CALLBACK messiahMAXUtilDlgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch(msg)
	{
	case WM_INITDIALOG:
		{
			::theUtilityObj.Init(hWnd);
		}
		return TRUE;

	case WM_COMMAND:
		{
			switch(LOWORD(wParam))
			{

			case IDC_IMPORT_OBJS:
				{
					::theUtilityObj.ImportObjs();
				}
				return TRUE;

			case IDC_LAUNCH_GUI:
				{
					::messiahInterface();
				}
				return TRUE;

			}// switch wParam

		}// WM_COMMAND

		return FALSE;

	case WM_PAINT:
		{
			::theUtilityObj.Refresh();
		}
		return FALSE;

	case WM_CUSTEDIT_ENTER:
		{
			if( LOWORD(wParam) == IDC_SCALING )
			{
				float	val;
				BOOL	state;
				
				ICustEdit * ed = ::GetICustEdit( (HWND)(lParam) );

				val = ed->GetFloat(&state);

				if( state )
					::theUtilityObj.d_scaleFactor = val;
				else
					::MessageBox(NULL, "Invalid Scale Factor", "messiahMAX ERROR", 0);

				return TRUE;
			}
		}
		return FALSE;

		return FALSE;

	}// switch msg

	return FALSE;
}

// ===============================================================
// messiahMAXutility::BeginEditParams
// ===============================================================
void messiahMAXutility::BeginEditParams(Interface *ip, IUtil *iu)
{
	// start messiah if it isn't already
	messiahStart(HOST_APP_NAME, HOST_MODULE_NAME, hostGlobal, MESSIAH_HOSTAPI_VERSION);

	this->ip = ip;
	this->iu = iu;

	this->hPanel = ip->AddRollupPage(hInstance,
									MAKEINTRESOURCE(IDD_UTIL_PANEL),
									messiahMAXUtilDlgProc,
									GetString(IDS_UTIL_CLASS_NAME),
									0);
}

// ===============================================================
// messiahMAXutility::EndEditParams
// ===============================================================
void messiahMAXutility::EndEditParams(Interface *ip, IUtil *iu)
{
	this->ip = NULL;
	this->iu = NULL;

	ip->DeleteRollupPage(this->hPanel);

	this->hPanel = NULL;
	this->hNumObjsLabel = NULL;
}

// ===============================================================
// messiahMAXutility::Init - not sure that this is needed...
// ===============================================================
void messiahMAXutility::Init(HWND hwnd)
{
	this->hPanel = hwnd;
	this->hNumObjsLabel = ::GetDlgItem(hwnd, IDC_NUM_OBJS_ON_DECK);
	this->hScale		= ::GetDlgItem(hwnd, IDC_SCALING);
	this->hScaleGroup	= ::GetDlgItem(hwnd, IDC_SCALING_GROUP);
	this->hScaleLabel1	= ::GetDlgItem(hwnd, IDC_SCALING_CAPTION1);
	this->hScaleLabel2	= ::GetDlgItem(hwnd, IDC_SCALING_CAPTION2);
	this->hImportButton = ::GetDlgItem(hwnd, IDC_IMPORT_OBJS);

	ICustEdit *ed	= ::GetICustEdit( this->hScale );
	ed->SetText( ::theUtilityObj.d_scaleFactor );
}

/*
class edgeItem
{
public:
	edgeItem(int vt1, int vt2, int fc1, int fpos1)
		: v1(vt1), v2(vt2), f1(fc1), fpos(fpos1) {}

	operator ==(edgeItem const &rhs)
	{
		if( (rhs.v1 == v1 && rhs.v2 == v2) ||
			(rhs.v2 == v1 && rhs.v1 == v2)  )
			return true;
		return false;
	}

	int	v1;
	int	v2;
	int	f1;
	int fpos;
};

class edgeList
{
public:

	typedef vector<edgeItem>	t_list;
	t_list	d_list;

	void	insert(edgeItem &ed)
	{
		t_list::iterator	it;

		it = find(d_list.begin(), d_list.end(), ed);
		if( it == d_list.end() )
			d_list.push_back( ed );
	}
};
*/

// ===============================================================
// messiahMAXutility::ImportObjs
// ===============================================================
void messiahMAXutility::ImportObjs()
{
	// if nothing is on deck no need to proceede
	if( this->d_objQ.empty() )
	{
		::MessageBox(NULL, "No objects waiting to be imported. To import an object from messiah, select it and press F12, then come back to this panel and press \"Import\"",
							"messiahMAX Error", 0);
		return;
	}

	vector<objOnDeck *>::iterator	it = this->d_objQ.begin();

	// iterate over waiting objs and add them to Max
	while( it != this->d_objQ.end() )
	{
		PolyObject *pobj = NULL;
		messiahMAX * mod = NULL;
		IDerivedObject *dobj = NULL;
		INode *node = NULL;

		try
		{
			// Create new PolyObj instance
			if( !(pobj = (PolyObject *)ip->CreateInstance(GEOMOBJECT_CLASS_ID, polyObjectClassID)) ) 
				throw mmax_exception("Failed to create PolyObject");

			// TODO: Copy mesh to Max
			MNMesh &mm = pobj->mm;
			int		mobj = (*it)->d_messiahObj;

			int		numVerts = nodeObjectNumPoints( mobj );
			int		numFaces = nodeObjectNumPolygons( mobj );
			int		numSurfaces = nodeObjectNumSurfaces( mobj );

			int i;

			// Copy Vertices from messiah to Max
			for( i = 0; i < numVerts; i++ )
			{
				double	x, y, z;
				nodeObjectGetFilePoint( mobj, i, &x, &y, &z );
				Point3 pt(x / ::theUtilityObj.d_scaleFactor, 
						  z / ::theUtilityObj.d_scaleFactor, 
						  y / ::theUtilityObj.d_scaleFactor);
				
				mm.NewVert(pt);
			}			

			// Copy Polygons from messiah to Max
			for( i = 0; i < numFaces; i++ )
			{
				int polypts = 0;
				int srfid	= 0;
				int pntlist[MMAX_MAX_PTS_PER_POLY] = {0};
				int flipped[MMAX_MAX_PTS_PER_POLY] = {0};

				nodeObjectGetPolygon( mobj, i, pntlist, MMAX_MAX_PTS_PER_POLY, &polypts, &srfid );

				// flip normals
				for(int j = 0; j < polypts; j++)
					flipped[j] = pntlist[polypts-j-1];

				// Create Face
				int ret = mm.CreateFace( polypts, flipped );


			}

			// If plug type is deformer
			if( (*it)->d_plugType == FX_NODE_DISPLACEMENT )
			{
				// Create messiahMAXmodifier
				if( !(mod = (messiahMAX *)ip->CreateInstance(OSM_CLASS_ID, MESSIAHMAX_CLASS_ID)) )
					throw mmax_exception("Failed to create messiahMAX modifier");

				// Create derived obj from PolyObj
				if( !(dobj = CreateDerivedObject(pobj)) )
					throw mmax_exception("Failed to create OSM");

				// Create local data
				messiahData * m_data = new messiahData();
				m_data->messiah_object = (*it)->d_messiahObj;

				// Create new ModContext
				ModContext * mc = new ModContext(new Matrix3(1), 0, m_data);
				mc->localData = m_data;

				// Create FX_NodeLog
				FX_NodeLog * log = nodeLogElement( (void *)mod, (void *)0x1,
									(void *)mc, (*it)->d_messiahObj);
				if( !log )
					throw mmax_exception("Failed to connect new object to messiah");
				log->type = MMAX_DFORMER;

				// Get obj name
				char objName[MMAX_MAX_OBJ_NAME] = {"messiah_object"};
				nodeObjectNameGet( (*it)->d_messiahObj, objName, MMAX_MAX_OBJ_NAME - 1 );

				// Add modifier to derived obj
				dobj->AddModifier(mod, mc);

				// Create new INode for derived obj
				if( !(node = ip->CreateObjectNode(dobj)) )
					throw mmax_exception("Failed to create new Max node");
				log->element = node;

				// Create unique name
				TSTR name(_T(objName));
				ip->MakeNameUnique(name);

				// Assign name to node
				node->SetName(name);

				// Refresh the viewports
				ip->RedrawViews(ip->GetTime());
			}
			else if( (*it)->d_plugType == FX_NODE_MOTION )
			{
//				if( !(ctl = (messiahMAXcontroller *)ip->CreateInstance(OSM_CLASS_ID, MESSIAHCTRL_CLASS_ID)) )
//					throw mmax_exception("Failed to create messiahMax controller");


			}
		}
		catch(mmax_exception &e)
		{
			char message[1024] = {0};
			::sprintf(message, "While creating new object the following error was encountered: %s \nAttempt to import remaining item(s)?",
								e.what() );

			int ret = ::MessageBox(NULL, message, "messiahMAX Error", MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2);


			// TODO: handle cleanup, remove items from max that have already been added

			if( ret == IDNO )
				return;
		}

		pobj = NULL;
		mod = NULL;
		dobj = NULL;
		node = NULL;

		it++;
	}

	// remove waiting items from vector
	it = this->d_objQ.begin();
	while( it != this->d_objQ.end() )
	{
		delete *it;
		it++;
	}
	this->d_objQ.clear();

	::theUtilityObj.ip->RedrawViews (::theUtilityObj.ip->GetTime());

	::theUtilityObj.Refresh();
}

void messiahMAXutility::Refresh()
{
	// Set On Deck Count Label
	static char numLabel[5] = {0};
	int n = ::theUtilityObj.d_objQ.size();
	sprintf(numLabel, "%d", n);
	::SetWindowText(::theUtilityObj.hNumObjsLabel, numLabel);
	
	// Set Enabled State of Scaling Group
	::EnableWindow(::theUtilityObj.hScale,		::plugMan.plugins.empty() ? TRUE : FALSE );
	::EnableWindow(::theUtilityObj.hScaleGroup,	::plugMan.plugins.empty() ? TRUE : FALSE );
	::EnableWindow(::theUtilityObj.hScaleLabel1,::plugMan.plugins.empty() ? TRUE : FALSE );
	::EnableWindow(::theUtilityObj.hScaleLabel2,::plugMan.plugins.empty() ? TRUE : FALSE );

	// Set Enabled State of Import Button
	::EnableWindow(::theUtilityObj.hImportButton, this->d_objQ.empty() ? FALSE : TRUE );
}

messiahMAXutility::~messiahMAXutility()
{
	// free any remaining "on deck" objs
	vector<objOnDeck *>::iterator	it = this->d_objQ.begin();
	while( it != this->d_objQ.end() )
	{
		delete (*it);
		it++;
	}
}

// ===============================================================
// manager Implementation
// ===============================================================
FX_NodeLog *	manager::GetNodeLog(int messiah_object)
{
	if(!messiah_object)
		return NULL;

	void * m_obj = NULL;

	FX_NodeLog *cur = nodeGetFirst(); //node_log;
	
	while( cur )
	{
		if( cur->obj == messiah_object )
			return cur;

		cur = cur->next;
	}

	return NULL;
}

// returns the messiah object with the given index
int			manager::GetObjFromIndex(int index)
{
//	return nodeSearchElement( index );

	FX_NodeLog *cur = node_log;

	if( cur->ID == 0 && cur->next->ID == 0 )
		cur = cur->next;

	while( cur )
	{
		if( cur->ID == index )
			return cur->obj;

		cur = cur->next;
	}

	return 0;

}


// ===============================================================
// Paramater Block Definition 
// ===============================================================
enum { messiahmax_params };

static ParamBlockDesc2 messiahmax_param_blk ( messiahmax_params, _T("params"),  0, &messiahMAXDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, &DialogProc, end );

static ParamBlockDesc2 messiahmaxCtrl_param_blk ( messiahmax_params, _T("params"),  0, &messiahMAXctrlDesc, 
	P_AUTO_CONSTRUCT + P_AUTO_UI, PBLOCK_REF, 
	//rollout
	IDD_PANEL, IDS_PARAMS, 0, 0, &DialogProc, end );

// ===============================================================
// Global Functions
// ===============================================================



//---------------------------------------------------------------------------
//	Name:	hostLoadmessiahHOST
//	Purpose:Required messiahHOST module loader.  Called from host.
//---------------------------------------------------------------------------
__EXPORTVAR(int) hostLoadmessiahHOST(void)
{
	HMODULE				hostmodule;
	char				libpath[512], curdir[512];
	int					i;

	if (messiahlib) return TRUE; //library already loaded

	hostmodule = GetModuleHandle(HOST_MODULE_NAME); 
	GetModuleFileName(hostmodule, curdir, 512); 

	//Path to scan for messiahHOST--------------------------------------
	i = strlen(curdir);
	curdir[i-strlen(HOST_MODULE_NAME)] = '\0';

	sprintf(libpath,"%s%s",curdir,MESSIAH_MODULE_NAME);


	//load messiahHOST--------------------------------------------------
	if (messiahlib = LoadLibrary(libpath))
	{
		if (messiahGlobal = (void *(__cdecl *)(char [])) GetProcAddress(messiahlib, "messiahGlobal"))
		{
			hostGlobalsGetAll();
		}
		else
		{
			FreeLibrary(messiahlib);
			messiahlib = NULL;
			return FALSE;
		}

		return TRUE;
	}

	return FALSE;
}


//---------------------------------------------------------------------------
//	Name:	hostObjectRename
//	Purpose:Required host object rename function
//---------------------------------------------------------------------------

__EXPORTVAR(int) hostObjectRename(FX_NodeLog *nd, int flags)
{
	messiahMAX		*ref=NULL;
	ModContext		*mc;
	Object			*obj;

	if (!nd || !(ref=(messiahMAX*)nd->ref) || !(obj=(Object*)nd->element) || !(mc=(ModContext*)nd->data) || !nd->obj) return FALSE;

/*	if (node = FindNodeReference(ref, mc))
		nodeObjectRename(nd->obj, node->GetName(),0);
	else
		nodeObjectRename(nd->obj,obj->GetObjectName(),0);
*/
	return TRUE;
}

//---------------------------------------------------------------------------
//	Name:	hostObjectGeometryCopy
//	Purpose:Required host object geometry creation function
//---------------------------------------------------------------------------
void genericSurfaceCopy (int messiah_object, Material *material, Mtl *m)
{
	if( m )
	{
		Color color;

		color = m->GetAmbient( 0, FALSE );
		nodeObjectSurfaceSet( messiah_object, 0, "Ambient", color );

		color = m->GetDiffuse(0, FALSE);
		nodeObjectSurfaceSet(messiah_object, 0, "Diffuse", color);

		color.r = m->GetShinStr(0, FALSE);
		nodeObjectSurfaceSet(messiah_object, 0, "Specular", color);

		color.r = m->GetShininess(0, FALSE)*100.0f;
		nodeObjectSurfaceSet(messiah_object, 0, "Shininess", color);

		color.r = m->GetSelfIllum(0, FALSE);
		nodeObjectSurfaceSet(messiah_object, 0, "Luminous", color);

		color.r = m->GetXParency(0, FALSE);
		nodeObjectSurfaceSet(messiah_object, 0, "Transparency", color);
	}// if m
	else if( material )
	{
		nodeObjectSurfaceSet(messiah_object, 0, "Ambient", material->Kd);
		nodeObjectSurfaceSet(messiah_object, 0, "Specular", &material->Ks);
		nodeObjectSurfaceSet(messiah_object, 0, "Shininess", &material->shininess);
		nodeObjectSurfaceSet(messiah_object, 0, "Luminous", &material->selfIllum);
	}// if material
}

void genericGeometryCopy(INode *node, int messiah_object, int add_to_hierarchy, Object *o)
{
	if( !node || !messiah_object ) return;

	char * name = node->GetName();
	
	ObjectState		os = node->EvalWorldState(GetCOREInterface()->GetTime());
	Material *		material = node->Mtls();
	Mtl *			m = node->GetMtl();
	Object *		obj = os.obj;

	if( o )
		obj = o;

	int				i, j, k;

	// Poly Object /////////////////////////////
	if( obj->IsSubClassOf( polyObjectClassID ) )
	{
		PolyObject *	pobj = (PolyObject *)obj;
		MNMesh &		mnmesh = pobj->GetMesh();
		MNVert *		mnvert = NULL;

		int				num_points, num_faces;
		double			point[3];
		Point3			vert;


		num_points = mnmesh.numv;
		num_faces = mnmesh.numf;

		// lines omitted temporarily
		// they copied the node log messiah obj to the mod context messiah obj
		// not sure why they would differ... but they do...

		// Create Points ///////////////////////
		for( i = 0; i < num_points; i++ )
		{
			mnvert = mnmesh.V(i);
			point[0] = (double)mnvert->p[0] * ::theUtilityObj.d_scaleFactor;	//0.01;
			point[1] = (double)mnvert->p[2] * ::theUtilityObj.d_scaleFactor;
			point[2] = (double)mnvert->p[1] * ::theUtilityObj.d_scaleFactor;
			nodeObjectCreatePoint( messiah_object, point[0], point[1], point[2] );
		}

		// Create Surfaces /////////////////////
		nodeObjectCreateSurface( messiah_object, node->GetName() );
		genericSurfaceCopy(messiah_object, material, m);

		// Create Polygons /////////////////////
		for (i=0; i<num_faces; i++)
		{
			MNFace *	mnface = mnmesh.F(i);
			int *		npnts = new int[ mnface->deg ];

			// copy vertex references over in reverse order (due to handedness flip)
			for( j = 0, k = mnface->deg -1; j < mnface->deg; j++, k--)
				npnts[j] = mnface->vtx[k];

			nodeObjectCreatePoly( messiah_object, mnface->deg, npnts, (unsigned short)1, 0 );

			delete [] npnts;
		}

		// Finish //////////////////////////////
		nodeObjectEnd( messiah_object, add_to_hierarchy );

	}///////////////////////////////////////////

	else //catch all for types not directly supported, they should be able to convert themselves to tri's
	{
		if (obj->CanConvertToType(Class_ID(TRIOBJ_CLASS_ID, 0)))
		{
			TriObject *		tobj = (TriObject *)obj->ConvertToType(0, Class_ID(TRIOBJ_CLASS_ID, 0) );
			bool			deleteIt = (tobj != obj); // we are responsible for deleting any NEW objects returned from ConvertToType
			Mesh &			mesh = tobj->GetMesh();

			int				num_points, num_faces;
			double			point[3];
			Point3			vert;

			num_points = mesh.numVerts;
			num_faces = mesh.numFaces;

			// as above, lines temporarily omitted

			// Create Points ///////////////////////
			for( i = 0; i < num_points; i++)
			{
				vert = mesh.verts[i];
				point[0] = (double)vert.x * ::theUtilityObj.d_scaleFactor;
				point[1] = (double)vert.z * ::theUtilityObj.d_scaleFactor;
				point[2] = (double)vert.y * ::theUtilityObj.d_scaleFactor;
				nodeObjectCreatePoint(messiah_object, point[0], point[1], point[2] );
			}
			// Create Surfaces /////////////////////
			nodeObjectCreateSurface( messiah_object, node->GetName() );
			genericSurfaceCopy(messiah_object, material, m);

			// Create Polygons /////////////////////
			int ppnts[3];

			for( i = 0; i < num_faces; i++)
			{
				ppnts[0] = (int)mesh.faces[i].v[2];
				ppnts[1] = (int)mesh.faces[i].v[1];
				ppnts[2] = (int)mesh.faces[i].v[0];
				nodeObjectCreatePoly(messiah_object, 3, ppnts, (unsigned short)1, 0);
			}

			// Finish //////////////////////////////
			nodeObjectEnd( messiah_object, add_to_hierarchy );
			if( deleteIt )
				tobj->DeleteMe();

		}// can convert to tri object

	}///////////////////////////////////////////

}
__EXPORTVAR(void*)	hostObjectConstruct(int obj, int flags)
{
	if(!obj)
		return NULL;

	objOnDeck *		onDeck = new objOnDeck(obj, flags, 0, 0);

	::theUtilityObj.d_objQ.push_back(onDeck);

	return (void *)(onDeck);
}

__EXPORTVAR(int)	hostAddPlugin(void *obj_data, int obj, int messiah_plugtype, int flags)
{
	if(!obj_data || !obj)
		return FALSE;

	objOnDeck *		onDeck = reinterpret_cast<objOnDeck *>(obj_data);
	
	onDeck->d_plugType = messiah_plugtype;
	onDeck->d_plugFlags = flags;

	return TRUE;
}

__EXPORTVAR(int) hostObjectGeometryCopy(FX_NodeLog *nd, int add_to_hierarchy)
{
/*	Material		*material=NULL;
	Mtl				*m=NULL;
	INode			*node;
	messiahData		*m_data=NULL;
	messiahMAX		*ref=NULL;
	ModContext		*mc;
	Object			*obj;
	int				i, num_points, num_faces, ppnts[3], *npnts;
	double			point[3];
	Point3			vert;
*///ron
	if( !nd ) return FALSE;

	// store the messiah_object in the local data so that the node log can be rebuilt
	if( loading_MAX_scene || merging_MAX_scene )
	{
		ModContext * mc = (ModContext *)nd->data;
		messiahData * data = (messiahData *)mc->localData;
		data->messiah_object = nd->obj;
	}		

	if( nd->type == MMAX_XFORMER )
	{
		genericGeometryCopy( (INode *)nd->data, nd->obj, add_to_hierarchy );
		return TRUE;
	}
	else if( nd->type == MMAX_DFORMER )
	{
		genericGeometryCopy( (INode *)FindNodeReference((messiahMAX*)nd->ref, 
							 (ModContext*)nd->data), nd->obj, add_to_hierarchy );
		return TRUE;
	}

	return FALSE;
	
/*
	if (!nd || !(ref=(messiahMAX*)nd->ref) || !(obj=(Object*)nd->element) || !(mc=(ModContext*)nd->data) || !nd->obj) return FALSE;



/*	if (node = FindNodeReference(ref, mc))
	{
		ObjectState os = node->EvalWorldState(GetCOREInterface()->GetTime());
		material = node->Mtls();   // Array  of GraphicsWindow Materials 
		m = node->GetMtl();
		obj = os.obj;
	}
*/
	/*
	if (obj->IsSubClassOf(polyObjectClassID))
	{
		PolyObject	*pobj = (PolyObject *)obj;
		MNMesh		&mnmesh = pobj->GetMesh();
		MNVert *	mnvert = NULL;

		num_points = mnmesh.numv;
		num_faces = mnmesh.numf;

		m_data =  (messiahData*)mc->localData;
		m_data->messiah_object = nd->obj;

		for (i=0; i<num_points; i++)
		{
			mnvert = mnmesh.V(i);
			point[0] = (double)mnvert->p[0]*0.01;
			point[1] = (double)mnvert->p[2]*0.01;
			point[2] = (double)mnvert->p[1]*0.01;
			nodeObjectCreatePoint(m_data->messiah_object, point[0], point[1], point[2]);
		}

		//if (m) nodeObjectCreateSurface(m_data->messiah_object, m->GetName());
		if (node) nodeObjectCreateSurface(m_data->messiah_object, node->GetName());
		else nodeObjectCreateSurface(m_data->messiah_object, obj->GetObjectName());

		if (m)
		{
			Color color;

			color = m->GetAmbient(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", color);

			color = m->GetDiffuse(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Diffuse", color);

			color.r = m->GetShinStr(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", color);

			color.r = m->GetShininess(0, FALSE)*100.0f;
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Shininess", color);

			color.r = m->GetSelfIllum(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Luminous", color);

			color.r = m->GetXParency(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Transparency", color);
		}
		else if (material)
		{
//				int		num_materials = node->NumMtls();
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", material->Kd);
//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", material->Ka);
//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Diffuse", material->Kd);
//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", &material->shinStrength);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", &material->Ks);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Shininess", &material->shininess);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Luminous", &material->selfIllum);
//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Transparency", &material->opacity);
		}

		for (i=0; i<num_faces; i++)
		{
			MNFace *mnface = NULL;
			mnface = mnmesh.F(i);
			npnts = new int[mnface->deg];
			int j, k;

			for( j = 0, k = mnface->deg -1; j < mnface->deg; j++, k--)
				npnts[j] = mnface->vtx[k];

			nodeObjectCreatePoly(m_data->messiah_object, mnface->deg, npnts, (unsigned short)1, 0);

			delete [] npnts;
		}
	
		nodeObjectEnd(m_data->messiah_object, add_to_hierarchy);

	}// if polyObject
	else if (obj->IsSubClassOf(triObjectClassID))
	{
		TriObject	*tobj = (TriObject*)obj;
		Mesh		&mesh = tobj->GetMesh();

		num_points = mesh.numVerts;
		num_faces = mesh.numFaces;

		m_data =  (messiahData*)mc->localData;
		m_data->messiah_object = nd->obj;

		for (i=0; i<num_points; i++)
		{
			vert = mesh.verts[i];// * mat;
			point[0] = (double)vert.x*0.01;
			point[1] = (double)vert.z*0.01;
			point[2] = (double)vert.y*0.01;
			nodeObjectCreatePoint(m_data->messiah_object, point[0], point[1], point[2]);
		}

		//if (m) nodeObjectCreateSurface(m_data->messiah_object, m->GetName());
		if (node) nodeObjectCreateSurface(m_data->messiah_object, node->GetName());
		else nodeObjectCreateSurface(m_data->messiah_object, obj->GetObjectName());

		if (m)
		{
			Color color;

			color = m->GetAmbient(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", color);

			color = m->GetDiffuse(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Diffuse", color);

			color.r = m->GetShinStr(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", color);

			color.r = m->GetShininess(0, FALSE)*100.0f;
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Shininess", color);

			color.r = m->GetSelfIllum(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Luminous", color);

			color.r = m->GetXParency(0, FALSE);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Transparency", color);
		}
		else if (material)
		{
			int		num_materials = node->NumMtls();
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", material->Kd);
	//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Ambient", material->Ka);
	//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Diffuse", material->Kd);
	//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", &material->shinStrength);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Specular", &material->Ks);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Shininess", &material->shininess);
			nodeObjectSurfaceSet(m_data->messiah_object, 0, "Luminous", &material->selfIllum);
	//				nodeObjectSurfaceSet(m_data->messiah_object, 0, "Transparency", &material->opacity);
		}

		for (i=0; i<num_faces; i++)
		{
			ppnts[0] = (int)mesh.faces[i].v[2];
			ppnts[1] = (int)mesh.faces[i].v[1];
			ppnts[2] = (int)mesh.faces[i].v[0];
			nodeObjectCreatePoly(m_data->messiah_object, 3, ppnts, (unsigned short)1, 0);
		}

		nodeObjectEnd(m_data->messiah_object, add_to_hierarchy);
	}
	else return FALSE;


	return TRUE;
	*///ron
}

__EXPORTVAR(int) hostObjectGetPoints(FX_NodeLog *nd, int reset_object)
{
	return FALSE;
}

//Find the node corresponding to the modifier and modcontext
INode* FindNodeReference( ReferenceTarget *modifier, ModContext *mod_context ) 
{
	DependentIterator	di( modifier );
	ReferenceMaker		*reference_maker;

	while ( reference_maker = di.Next() ) 
	{ 
		if ( reference_maker->SuperClassID() == BASENODE_CLASS_ID ) 
		{
			INode *node = ( INode * )reference_maker;
			Object *object = node->GetObjectRef();

			//Get modifier and modcontext and see which one matches
			if ( object && (object->SuperClassID()==GEN_DERIVOB_CLASS_ID ))
//			if ( object )
			{
				IDerivedObject	*derived_object = ( IDerivedObject *)object;
				int			modifier_index;
				int			num_modifiers = derived_object->NumModifiers();

				for (modifier_index=0; modifier_index<num_modifiers; modifier_index++)
				{
					Modifier *modifier = derived_object->GetModifier( modifier_index );
					ModContext *modifier_context = derived_object->GetModContext( modifier_index );

					if( modifier_context == mod_context ) return node;
				} 
			} 
		}

		// section removed, see removedFromMessiahMax.cpp

		if( reference_maker->IsRefTarget() )
		{
			INode *node = FindNodeReference( ( ReferenceTarget*)reference_maker, mod_context );

			if( node ) return node;
		}
	}

	return NULL;
}

// ===============================================================
// Callbacks
// ===============================================================

void NotifyPreLoad(void *param, NotifyInfo *info)
{
	loading_MAX_scene = 1;
	scene_exists = 0;

	if( *messiah_Activated & MESSIAH_ACTIVATED_SYSTEM )
		nodeClearAllElements(2);	// clear the node log and the items from messiah

	plugMan.plugins.clear();
	plugMan.loadingList.clear();
	plugMan.tmpMClist.clear();

	/*
	if (loaded_ref_pointers)
	{
		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}
	num_loaded_refs = 0;

	//Clear existing messiah scene (2)

	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;

	nodeClearAllElements(2);
	*/// ron
}


void NotifyPostLoad(void *param, NotifyInfo *info)
{

	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;

	// load the scene
	if( scene_exists )
		messiahSceneLoad(MESSIAH_SCENE_LOAD);

	// move items from the loading list to the plugin list
	manager::plugIter	it = plugMan.loadingList.begin();
	while( it != plugMan.loadingList.end() )
	{
		plugMan.plugins.push_back( *it );
		it++;
	}
	plugMan.loadingList.clear();

	// rebuild node log //////////////////////////////////////////////////////////
	if( !((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;
	if( plugMan.plugins.empty() ) return;

	nodeClearAllElements(0);

	FX_NodeLog *log = NULL;
	it = plugMan.plugins.begin();
	
	messiahMAX *m = NULL;
	messiahMAXcontroller *p = NULL;
	messiahData *data = NULL;
	manager::mcIter		mcIt;

	while( it != plugMan.plugins.end() )
	{
		switch( (*it)->type )
		{
		case MMAX_DFORMER:
			m = (messiahMAX *)*it;

			if(!m)
				break;

			plugMan.tmpMClist.clear();		// clear the tmp list
			m->EnumModContexts(&EnumMC);	// now fill it with the mc's

			mcIt = plugMan.tmpMClist.begin();

			while( mcIt != plugMan.tmpMClist.end() )
			{	

				INode *n = FindNodeReference(m, *mcIt);
				if(!n)
					continue;
				
				Object *o = n->GetObjectRef();
				if(!o)
					continue;

				data = (messiahData *)( (*mcIt)->localData );
				log = nodeLogElement( (void *)m, (void *)o, (void *)*mcIt, data->messiah_object );
				log->type = MMAX_DFORMER;

				mcIt++;
			}

			// log each of the elements that this modifier is attached to
			// i.e. one log entry for each mod context

			break;

		case MMAX_XFORMER:
			p = (messiahMAXcontroller *)*it;

			if(!p)
				break;;

			// log the element
			log = nodeLogElement( NULL, (void *)1, NULL, p->messiah_data.messiah_object);
			log->type = MMAX_XFORMER;

			break;

		}

		it++;
	}
	//////////////////////////////////////////////////////////////////////////////////////

	loading_MAX_scene = 0;
	messiahUpdate(0);


}


void NotifyPreSave(void *param, NotifyInfo *info)
{
	num_saved = 0;

	// rebuild node log //////////////////////////////////////////////////////////
	if( !((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;
	if( plugMan.plugins.empty() ) return;

	nodeClearAllElements(0);

	FX_NodeLog *log = NULL;
	manager::plugIter	it = plugMan.plugins.begin();
	
	messiahMAX *m = NULL;
	messiahMAXcontroller *p = NULL;
	messiahData *data = NULL;
	manager::mcIter		mcIt;

	while( it != plugMan.plugins.end() )
	{
		switch( (*it)->type )
		{
		case MMAX_DFORMER:
			m = (messiahMAX *)*it;

			if(!m)
				break;

			plugMan.tmpMClist.clear();		// clear the tmp list
			m->EnumModContexts(&EnumMC);	// now fill it with the mc's

			mcIt = plugMan.tmpMClist.begin();

			while( mcIt != plugMan.tmpMClist.end() )
			{	
				data = (messiahData *)( (*mcIt)->localData );
				log = nodeLogElement( NULL, (void *)1, NULL, data->messiah_object );
				log->type = MMAX_DFORMER;

				mcIt++;
			}

			// log each of the elements that this modifier is attached to
			// i.e. one log entry for each mod context

			break;

		case MMAX_XFORMER:
			p = (messiahMAXcontroller *)*it;

			if(!p)
				break;;

			// log the element
			log = nodeLogElement( NULL, (void *)1, NULL, p->messiah_data.messiah_object);
			log->type = MMAX_XFORMER;

			break;

		}

		it++;
	}
	//////////////////////////////////////////////////////////////////////////////////////

/*	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;

	if (!ref_counter) return;

	//Initialize all buffers...........................................................
	nodeClearAllElements(0);

	if (loaded_ref_pointers)
	{
		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}
	num_loaded_refs = 0;

//ron	num_presave_refs = CollectModifiers(GetCOREInterface()->GetRootNode(), 2);
	num_saved_refs = 0;

	if (saved_ref_pointers)
	{
		int counter = 0;
		int	i;

		for (i=0;i<num_presave_refs;i++)
		{
//ron			LogNodeData(saved_ref_pointers[i], saved_ref_pointers[i], &counter);
		}

		free(saved_ref_pointers);
		saved_ref_pointers = NULL;
	}
*///ron
	saving_MAX_scene = 1;
}


void NotifyPostSave(void *param, NotifyInfo *info)
{
/*	if (!ref_counter) return;

	//Get the objects that are currently in the scene........................................
//ron	CollectModifiers(GetCOREInterface()->GetRootNode(), 1);
	if (loaded_ref_pointers)
	{
		int counter = 0;
		int	i;

		for (i=0;i<num_loaded_refs;i++)
		{
//ron			LogNodeData(loaded_ref_pointers[i], loaded_ref_pointers[i], &counter);
		}

		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}
*///ron
	num_loaded_refs = 0;

	saving_MAX_scene = 0;
}


void NotifyPreMerge(void *param, NotifyInfo *info)
{
	merging_MAX_scene = 1;
	scene_exists = 0;
/*
	if (loaded_ref_pointers)
	{
		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}
	num_loaded_refs = 0;

	//Clear existing messiah scene (2)

	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;
*///ron
	nodeClearAllElements(0);

}

void NotifyPostMerge(void *param, NotifyInfo *info)
{

	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;

	// load the scene
	if( scene_exists )
		messiahSceneLoad(MESSIAH_SCENE_MERGE);

	// move items from the loading list to the plugin list
	manager::plugIter	it = plugMan.loadingList.begin();
	while( it != plugMan.loadingList.end() )
	{
		plugMan.plugins.push_back( *it );
		it++;
	}
	plugMan.loadingList.clear();

	// rebuild node log //////////////////////////////////////////////////////////
	if( !((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;
	if( plugMan.plugins.empty() ) return;

	nodeClearAllElements(0);

	FX_NodeLog *log = NULL;
	it = plugMan.plugins.begin();
	
	messiahMAX *m = NULL;
	messiahMAXcontroller *p = NULL;
	messiahData *data = NULL;
	manager::mcIter		mcIt;

	while( it != plugMan.plugins.end() )
	{
		switch( (*it)->type )
		{
		case MMAX_DFORMER:
			m = (messiahMAX *)*it;

			if(!m)
				break;

			plugMan.tmpMClist.clear();		// clear the tmp list
			m->EnumModContexts(&EnumMC);	// now fill it with the mc's

			mcIt = plugMan.tmpMClist.begin();

			while( mcIt != plugMan.tmpMClist.end() )
			{	

				INode *n = FindNodeReference(m, *mcIt);
				if(!n)
					continue;
				
				Object *o = n->GetObjectRef();
				if(!o)
					continue;

				data = (messiahData *)( (*mcIt)->localData );
				log = nodeLogElement( (void *)m, (void *)o, (void *)*mcIt, data->messiah_object );
				log->type = MMAX_DFORMER;

				mcIt++;
			}

			// log each of the elements that this modifier is attached to
			// i.e. one log entry for each mod context

			break;

		case MMAX_XFORMER:
			p = (messiahMAXcontroller *)*it;

			if(!p)
				break;;

			// log the element
			log = nodeLogElement( NULL, (void *)1, NULL, p->messiah_data.messiah_object);
			log->type = MMAX_XFORMER;

			break;

		}

		it++;
	}
	//////////////////////////////////////////////////////////////////////////////////////

	
	merging_MAX_scene = 0;
	messiahUpdate(0);

	/*
	int		i, counter = 0;

	if (!((*messiah_Activated)&MESSIAH_ACTIVATED_SYSTEM)) return;

	if (!ref_counter) return;

	//Get the objects from the loaded references.......................................
	if (loaded_ref_pointers)
	{
		if (scene_exists)
		{
			for (i=0;i<num_loaded_refs;i++)
			{
//ron				LogNodeData(loaded_ref_pointers[i], loaded_ref_pointers[i], &counter);
			}

			//Load the fxs into messiah.  HostManager will perform the reconnection.........
			messiahSceneLoad(MESSIAH_SCENE_MERGE);
		}

		//Initialize all buffers...........................................................
		nodeClearAllElements(0);
		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}

	num_loaded_refs = 0;

	//Get the objects that are currently in the scene........................................
//ron	CollectModifiers(GetCOREInterface()->GetRootNode(), 1);
	if (loaded_ref_pointers)
	{
		counter = 0;

		for (i=0;i<num_loaded_refs;i++)
		{
//ron			LogNodeData(loaded_ref_pointers[i], loaded_ref_pointers[i], &counter);
		}

		free(loaded_ref_pointers);
		loaded_ref_pointers = NULL;
	}

	num_loaded_refs = 0;

	merging_MAX_scene = 0;

	//Merge new messiah scene if it exists

	messiahUpdate(0);
	*///ron
}


void NotifyPreReset(void *param, NotifyInfo *info)
{
	reseting_MAX_scene = 1;
}

void NotifyPostReset(void *param, NotifyInfo *info)
{
	reseting_MAX_scene = 0;

	//Clear Messiah scene
	if( *messiah_Activated & MESSIAH_ACTIVATED_SYSTEM )
	{
		nodeClearAllElements(MESSIAH_SCENE_CLEAR);
		messiahUpdate(0);
	}

	plugMan.plugins.clear();
	plugMan.loadingList.clear();
	plugMan.tmpMClist.clear();
}


void NotifyPreNew(void *param, NotifyInfo *info)
{
	newing_MAX_scene = 1;
}

void NotifyPostNew(void *param, NotifyInfo *info)
{
	newing_MAX_scene = 0;
	if( *messiah_Activated & MESSIAH_ACTIVATED_SYSTEM )
	{
		nodeClearAllElements(MESSIAH_SCENE_CLEAR);
		messiahUpdate(0);
	}
	plugMan.plugins.clear();
	plugMan.loadingList.clear();
	plugMan.tmpMClist.clear();
}


void NotifySystemShutdown(void *param, NotifyInfo *info)
{
	if (messiahlib)
	{
		messiahShutdown();

		FreeLibrary(messiahlib);
		messiahlib = NULL;
	}
}



