//! Common Node Operations
/*!
	More detailed desc.
*/
//
// ===============		messiahCommonNodeOps.h		==============
//
// Copyright (C) 2002 pmG Worldwide LLC. All Rights Reserved.
//
// ===============================================================
//
// Description:
//
// Callbacks use by messiahMaya and messiah proper.Also class
// definition of commonNode which contains data elements common
// to both Dform and Xform nodes.
//
// ===============================================================
//
// Version History:
//
// Written By: Ron Griswold
// Date: 4/22/2002
//
// Revised By:
// Date: 
//
// ===============================================================
#ifndef MM_MESSIAHCOMMONNODEOPS
#define MM_MESSIAHCOMMONNODEOPS

#include "Params.h"
#include "ErrorCheck.h"

#include <maya/MNodeMessage.h>	// why is this included?
#include <maya/MDagPath.h>

class commonNode
{
public:

	commonNode() : _nodeLog(0) {}

public:	// instance data
	FX_NodeLog *	_nodeLog;
	MDagPath		_shape;
};

namespace common
{

void	AttributeRenamed			(MObject &node, void *data);

extern "C" void *		hostGlobal					(char *globalName );

// give messiah info
extern "C" int			hostObjectGeometryCopy		(FX_NodeLog *messiahNode, int addToHierarchy);
extern "C" int			hostObjectGetPoints			(FX_NodeLog *messiahNode, int resetObject);
extern "C" int			hostObjectRename			(FX_NodeLog *messiahNode, int flags);

// get info from messiah
extern "C" void *		hostObjectConstruct			(int obj, int flags);
extern "C" int			hostAddPlugin				(void *obj_data, int obj, int plugType, int flags);
extern "C" void *		hostObjectConstruct			(int obj, int flags);

bool	copyLocatorToMessiah		(MH_NodeObject &no, MObject mayaItem, int addToHierarchy);
bool	copyMeshToMessiah			(MH_NodeObject &no, MObject mayaItem, int addToHierarchy);
bool	copyNurbsToMessiah			(MH_NodeObject &no, MObject mayaItem, int addToHierarchy);
bool	copySubdivToMessiah			(MH_NodeObject &no, MObject mayaItem, int addToHierarchy);

}

#endif