#include "c4d_memory.h"
#include "c4d_baselist.h"

VariableChanged::VariableChanged(void)
{
	old_cnt=new_cnt=0;
	map=NULL;
	safety=TRUE;
}

Bool operator == (const Marker &m1,const Marker &m2)
{
	if ((m1.L1==0 && m1.L2==0) || (m2.L1==0 && m2.L2==0)) return FALSE;

	return (m1.L1==m2.L1) && (m1.L2==m2.L2);
}

Bool operator != (const Marker &m1,const Marker &m2)
{
	if ((m1.L1==0 && m1.L2==0) || (m2.L1==0 && m2.L2==0)) return TRUE;
	
	return (m1.L1!=m2.L1) || (m1.L2!=m2.L2);
}

Marker GeGetNewMarker(void)
{
	Marker m;
	C4DOS.Ge->GetNewMarker(&m.L1,&m.L2);
	return m;
}

LONG BaseList2D::GetDiskType(void)
{
	return C4DOS.Bl->GetDiskType(this);	
}

Marker BaseList2D::GetMarker (void)
{
	Marker m;
	C4DOS.Bl->GetMarker(this,&m.L1,&m.L2);
	return m;
}

void BaseList2D::InsertBefore(BaseList2D *bl)
{
	C4DOS.Bl->InsertBefore(this,bl);	
}

void BaseList2D::InsertAfter(BaseList2D *bl)
{
	C4DOS.Bl->InsertAfter(this,bl);	
}

void BaseList2D::Remove(void)
{
	C4DOS.Bl->Remove(this);	
}

void BaseList2D::ToggleBit(LONG mask)
{
	LONG bitfield = C4DOS.Bl->GetAllBits(this);

	if (bitfield & mask) 
		bitfield = bitfield & ~mask; 
	else 
		bitfield = bitfield | mask; 

	C4DOS.Bl->SetAllBits(this,bitfield);
}

LONG BaseList2D::GetColor(void) 
{
	return C4DOS.Bl->GetColor(this);	
}

void BaseList2D::SetColor(LONG c)
{
	C4DOS.Bl->SetColor(this,c);	
}

Bool BaseList2D::Message(LONG type, void *data)
{
	return C4DOS.Bl->Message(this,type,data);	
}

void BaseList4D::InsertUnder(BaseList4D *bl)
{
	C4DOS.Bl->InsertUnder(this,bl);	
}

void BaseList4D::InsertUnderLast(BaseList4D *bl)
{
	C4DOS.Bl->InsertUnderLast(this,bl);	
}
