#ifndef __C4DBASEMATERIAL_H
#define __C4DBASEMATERIAL_H

#include "operatingsystem.h"
#include "c4d_baselist.h"

class BaseMaterial : public BaseList2D
{
	private:
		BaseMaterial(void);
		~BaseMaterial(void);
	public:
		BaseMaterial *next(void) { return (BaseMaterial*)C4DOS.Bl->Next(this); }
		BaseMaterial *pred(void) { return (BaseMaterial*)C4DOS.Bl->Pred(this); }

		BaseDocument *GetDocument(void) { return (BaseDocument*)C4DOS.Bl->GetMain(this); }

		String GetName(void) { String str; if (!str.Get()) return String(); C4DOS.Mt->GetName(this,str.Get()); return str; }
		void	 SetName(const String &name) { C4DOS.Mt->SetName(this,name.Get()); }

		void Update(LONG preview, Bool rttm);

		Bool				 CopyTo(BaseMaterial *dest, LONG flags=0);  
		BaseMaterial *GetClone(LONG flags=0); 

		Bool					Edit(void); 

		void					SetData(const BaseContainer &bc);
		BaseContainer GetData(void);

		BaseChannel	  *GetChannel(LONG id) { return C4DOS.Mt->GetChannel(this,id); }

		Bool Compare(BaseMaterial *snd);
};

class Material : public BaseMaterial
{
	private:
		Material(void);
		~Material(void);
	public:
		Bool GetChannelState(LONG channel) { return C4DOS.Mt->GetChannelState(this,channel); }
		void SetChannelState(LONG channel, Bool state) { C4DOS.Mt->SetChannelState(this,channel,state); }
};

class PluginMaterial : public BaseMaterial
{
	private:
		PluginMaterial(void);
		~PluginMaterial(void);
	public:
		LONG					GetPluginID(void);
		PLUGIN_DATA		*GetPluginData(void);
		VOLUMESHADER	*GetShader(void);
};

BaseMaterial *AllocMaterial(LONG type, LONG shader_id);
#define FreeMaterial(v) { if (v) C4DOS.Bl->Free(v); v=NULL;}

#endif
