#include "c4d_basesound.h"
#include "c4d_file.h"
#include "operatingsystem.h"

BaseSound *BaseSound::GetClone(void)
{
	return C4DOS.Bu->GetClone(this);
}

Bool BaseSound::CopyTo(BaseSound *dest)
{
	return C4DOS.Bu->CopyTo(this,dest);
}

Bool BaseSound::Init(LONG samples, LONG fmode, Bool stereo, Bool b16)
{
	return C4DOS.Bu->Init(this,samples,fmode,stereo,b16);
}

void BaseSound::FlushAll(void)
{
	C4DOS.Bu->FlushAll(this);
}

Bool BaseSound::Load(const Filename &fn)
{
	if (!fn.Get()) return FALSE;
	return C4DOS.Bu->Load(this,fn.Get());
}

Bool BaseSound::Save(const Filename &fn)
{
	if (!fn.Get()) return FALSE;
	return C4DOS.Bu->Save(this,fn.Get());
}

void BaseSound::GetSoundInfo(Bool *stereo, Bool *b16, LONG *frequency, LONG *samples, BaseTime *length)
{
	C4DOS.Bu->GetSoundInfo(this,stereo,b16,frequency,samples,length);
}

void BaseSound::GetSample(LONG i, SData *data)
{
	C4DOS.Bu->GetSample(this,i,data);
}

void BaseSound::SetSample(LONG i, const SData &data)
{
	C4DOS.Bu->SetSample(this,i,(SData*)&data);
}

BaseBitmap *BaseSound::GetBitmap(LONG width, LONG height, const BaseTime &start, const BaseTime &stop)
{
	return C4DOS.Bu->GetBitmap(this,width,height,start,stop);
}

MarkerKey *BaseSound::GetFirstMarker(void)
{
	return C4DOS.Bu->GetFirstMarker(this);
}

Bool BaseSound::InsertMarker(MarkerKey *mk, MarkerKey *pred)
{
	return C4DOS.Bu->InsertMarker(this,mk,pred);
}

BaseSound *AllocBaseSound(void)
{
	return C4DOS.Bu->Alloc();
}

void FreeBaseSound(BaseSound *&bs)
{
	C4DOS.Bu->Free(bs);
	bs=NULL;
}
