#ifndef __C4D_MEMORY_H
#define __C4D_MEMORY_H

#include "c4d_plugin.h"

void _GeFree(void **Daten);

#define GeAlloc(x) C4DOS.Ge->Alloc(x)
#define GeFree(x) _GeFree((void **)(&(x)))

void ClearMem(void *d, LONG size, LONG value=0);
void CopyMem(void *s, void *d, LONG size);

#ifdef __MAC
#include <size_t.h>
#if defined(__cplusplus) && defined(_MSL_USING_NAMESPACE)
	using namespace std;
#endif

void* operator new(size_t s);
void* operator new[](size_t s);
void operator delete(void *p);
void operator delete[](void *p);

#else

void* operator new(unsigned int s);
void* operator new[](unsigned int s);
void operator delete(void *p);
void operator delete[](void *p);

#endif

#define gNew new
#define bNew new
#define gDelete(v) {if(v) delete v; v=0;}
#define bDelete(v) {if(v) delete [] v; v=0;}

class MemoryPool
{
	private:
		MemoryPool(void);
		~MemoryPool(void);
	public:
		void *Alloc (LONG size, Bool clear=TRUE);
		void Free   (void *mem, LONG size);
		void *AllocS(LONG size, Bool clear=TRUE);
		void FreeS	(void *mem);
};

MemoryPool *AllocMemoryPool(LONG block_size=0x80000);
void FreeMemoryPool(MemoryPool *&pool);

#endif