
#include "c4d_resource.h"
#include "c4d_gui.h"

#ifndef __API_INTERN__
#include "c4d_memory.h"
#include "c4d_file.h"
#endif

GeResource::GeResource(void)
{
	lr     = NULL;
	state  = FALSE;
	initfn = NULL;
	glob   = FALSE;
}

GeResource::~GeResource(void)
{
	if (glob) return;
	C4DOS.Lr->Free(lr);
	gDelete(initfn);
}

Bool GeResource::Init(void)
{
#ifndef __API_INTERN__
	return Init(GeGetPluginPath());
#else
	return Init(GeGetStartupPath());
#endif
}

Bool GeResource::Init(const Filename &path)
{
	if (!initfn)
	{
		initfn = gNew Filename(path);
		if (!initfn) return FALSE;
	}
#ifndef __API_INTERN__
	if (!path.Get()) return FALSE;
	if (state) return lr!=NULL;
	lr = C4DOS.Lr->Alloc(path.Get());
	state=TRUE;
	return lr!=NULL;
#else
	if (state) return lr!=NULL;
	lr = C4DOS.Lr->Alloc((Filename*)&path);
	state=TRUE;
	return lr!=NULL;
#endif
}

Bool GeResource::InitAsGlobal(void)
{
	glob=TRUE;
	lr=C4DOS.Lr->GetCinemaResource();
	return lr!=NULL;
}

Bool GeResource::Flush(void)
{
	if (glob) return TRUE;
	if (!initfn) return FALSE;
	C4DOS.Lr->Free(lr);
	lr    = NULL;
	state = FALSE;
	return Init(*initfn);
}

String GeResource::LoadString(LONG id)
{
#ifndef __API_INTERN__
	if (!lr) return String();
	return String(C4DOS.Lr->LoadString(lr,id),TRUE);
#else
	return GeLoadString(id);
#endif
}

#ifndef __API_INTERN__
GeResource resource;

String GeLoadString(LONG id)
{
	return resource.LoadString(id);
}

String GeLoadString(LONG id, const String &p1)
{
	LONG pos;
	String str=resource.LoadString(id);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p1);
	return str;
}

String GeLoadString(LONG id, const String &p1, const String &p2)
{
	LONG pos;
	String str=resource.LoadString(id);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p1);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p2);
	return str;
}

String GeLoadString(LONG id, const String &p1, const String &p2, const String &p3)
{
	LONG pos;
	String str=resource.LoadString(id);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p1);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p2);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p3);
	return str;
}

String GeLoadString(LONG id, const String &p1, const String &p2, const String &p3,const String &p4)
{
	LONG pos;
	String str=resource.LoadString(id);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p1);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p2);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p3);
	if (!str.FindFirst("#",&pos)) return String();
	str.Delete(pos,1);
	str.Insert(pos,p4);
	return str;
}
#endif
