/////////////////////////////////////////////////////////////
// CINEMA SDK : RENDERING																	 //
/////////////////////////////////////////////////////////////
// VERSION    : CINEMA 4D V6 AMBER												 //
/////////////////////////////////////////////////////////////
// (c) 1989-2001 MAXON Computer GmbH, all rights reserved	 //
/////////////////////////////////////////////////////////////

// video post classes

#ifndef __C4D_SCENEHOOK_H
#define __C4D_SCENEHOOK_H

#include "ge_vector.h"


class BaseDocument;
class BaseThread;


#define SCENEHOOK_INIT								(1<<0)
#define SCENEHOOK_FREE								(1<<1)
#define SCENEHOOK_BEFORE_ANIM					(1<<2)
#define SCENEHOOK_AFTER_ANIM					(1<<3)
#define SCENEHOOK_BEFORE_EXPRESSIONS	(1<<4)
#define SCENEHOOK_AFTER_EXPRESSIONS		(1<<5)

#define SCENEHOOK_RESULT_OK						(0)
#define SCENEHOOK_RESULT_USERBREAK		(1)
#define SCENEHOOK_RESULT_MEMORYERROR	(2)


struct SHExecuteArgs
{
	LONG         mode;				// SCENEHOOK_xxx
	BaseDocument *doc;				// pointer to basedocument
	BaseThread   *thread;			// thread for abort-test
	void         *userdata;		// pointer to userdata ... allocate it in SCENEHOOK_INIT and delete in SCENEHOOK_FREE
};

struct SCENEHOOK
{
	LONG level;			// disk level
	LONG info;			// SCENEHOOK_xxx bits, SCENEHOOK_INIT & SCENEHOOK_FREE are set automatically
	LONG priority;	// execution priority

	LONG			(*Execute         )(SHExecuteArgs &sh);
};

#endif
