/////////////////////////////////////////////////////////////
// CINEMA SDK : TAG / EXPRESSION													 //
/////////////////////////////////////////////////////////////
// VERSION    : CINEMA 4D V6 AMBER												 //
/////////////////////////////////////////////////////////////
// (c) 1989-2001 MAXON Computer GmbH, all rights reserved	 //
/////////////////////////////////////////////////////////////

#ifndef __C4D_TAGPLUGIN_H
#define __C4D_TAGPLUGIN_H

#include "ge_math.h"
#include "ge_prepass.h"

class PluginTag;
class BaseDocument;
class BaseObject;
class BaseDraw;
class BaseDrawHelp;
class BaseTag;
class HyperFile;
class BaseBitmap;
class _String;

struct TAGPLUGIN
{
	_String			*help;
	BaseBitmap	*icon;
	LONG				disklevel,info;

	Bool	(*AllocSettings	)(PluginTag *tag);
	void	(*FreeSettings	)(PluginTag *tag);
	Bool	(*CloneSettings	)(PluginTag *src, PluginTag *dst);
	Bool	(*ReadSettings	)(PluginTag *tag, HyperFile *hf, LONG level);
	Bool	(*WriteSettings	)(PluginTag *tag, HyperFile *hf);
	Bool	(*EditSettings	)(PluginTag *tag);
	Bool	(*Message				)(PluginTag *tag, LONG msg, void *data);

	Bool  (*Execute				)(PluginTag *tag, BaseDocument *doc, BaseObject *op);
	void	(*Speedup				)(PluginTag *tag, BaseDocument *doc, BaseObject *op);

	Bool	(*Draw					)(PluginTag *tag, BaseObject *op, BaseDraw *bd, BaseDrawHelp *bh);

	Bool add_menu;
};

#endif
