// Connection example

#include "c4d_file.h"
#include "c4d_tagplugin.h"
#include "c4d_general.h"
#include "c4d_memory.h"
#include "c4d_resource.h"
#include "c4d_basebitmap.h"
#include "c4d_basecontainer.h"
#include "c4d_basetag.h"
#include "c4d_tools.h"
#include "c4d_symbols.h"

#include "messiahConstants.h"

static Bool Message(PluginTag *tag, LONG msg, void *data)
{
  GePrint("Tag Message(): " + LongToString(msg) + " (" + LongToString((LONG)data) + ")");
  return TRUE;
}

static BaseBitmap* icon = NULL;
static BaseBitmap* icon_small = NULL;
static String* help = NULL;

Bool RegisterMessiahTag(void)
{
  // Get plugin name
	String name = GeLoadString(IDS_TAG_TEXT);

  // Load icons
	icon = AllocBaseBitmap();
	if (!icon || icon->Init(GeGetPluginPath() + String("res") + String("messiah.tif")) != IMAGE_OK) return FALSE;

	icon_small = AllocBaseBitmap();
	if (!icon_small || icon_small->Init(GeGetPluginPath()+String("res")+String("messiah_small.tif"))!=IMAGE_OK) return FALSE;

  // Load help string
  help = gNew String();
  *help = GeLoadString(IDS_TAG_HELP_TEXT);

  // Create tag plugin struct
	TAGPLUGIN cs;
	ClearMem(&cs,sizeof(cs));

  cs.disklevel        = 0;
	cs.add_menu					= TRUE;
	cs.help							= help->Get();
	cs.icon							= icon;
	cs.info							= TAG_VISIBLE;

  cs.Message          = Message;

	// Register plugin
	return GeRegisterPlugin(C4DPL_TAG, TAG_PLUGIN_ID, name, &cs, sizeof(cs));
}

void FreeMessiahTag(void)
{
	FreeBaseBitmap(icon);
	FreeBaseBitmap(icon_small);
  gDelete(help);
}
