#include "messiahDLL.h"


#include "c4d_memory.h"
#include "c4d_baseobject.h"

#include "messiahManager.h"

FX_NodeLog* nodeLogElement(void* a, void* b, void* c, void* d)
{
  GePrint("nodeLogElement");
  FX_NodeLog* res = gNew FX_NodeLog; // Leaking
  res->element = b;
  return res;
}

void* nodeObjectCreate(CHAR*a, LONG b, LONG c)
{
  GePrint("nodeObjectCreate");
  return (void*) 0x1234; // Dummy pointer
}

void nodeClearElement(FX_NodeLog* a, LONG b)
{
  GePrint("nodeClearElement");
}

void nodeObjectRebuild(void* messiah_node)
{
  GePrint("nodeObjectRebuild");
}


void messiahInterface()
{
  GePrint("messiahInterface");
}

void messiahWindow(LONG)
{
  GePrint("messiahWindow");
}

void messiahStart(CHAR* appName, CHAR* modName) {}
void messiahShutdown() {}

void nodeObjectCreatePoint(void* messiah_object, double x, double y, double z) {}
void nodeObjectCreatePoly(void* messiah_object, LONG numPoints, LONG* ppoints, LONG, LONG){}
void nodeObjectCreateSurface(void* messiah_object, const CHAR* name) {}
void nodeObjectEnd(void* messiah_object, LONG add_to_hierarchy) {}

CHAR* nodeSceneFileCreateBuff(CHAR* path, LONG* type)
{
  GePrint("nodeSceneFileCreateBuff");

  static CHAR* dummy = "Dummy data!";

  if (!type) return NULL;
  *type = MESSIAH_EMBEDDED_SCENE;
  return dummy;
}

void nodeSceneFileClearBuff(CHAR* buff)
{
  GePrint("nodeSceneFileClearBuff");
}

Bool nodeSceneFileLoadBuff(CHAR* buff)
{
  GePrint("nodeSceneFileLoadBuff");
  return TRUE;
}

Bool nodeSceneFileLoadPath(CHAR* buff)
{
  GePrint("nodeSceneFileLoadPath");
  return TRUE;
}

void nodeSceneLoad(LONG a)
{
  GePrint("nodeSceneLoad");
}

static double hack_t = 0.0;

void nodeCheckTime(double t, LONG a)
{
  hack_t = t;
  // GePrint("nodeCheckTime: " + RealToString(t));
}

void nodeObjectGetPoint(void* messiah_object, LONG point, float* x, float* y, float* z)
{
}


extern "C" int hostObjectGeometryCopy(FX_NodeLog* messiah_node, LONG add_to_hierarchy)
{
  GePrint("hostObjectGeometryCopy");

  if (!messiah_node || !messiah_node->element || !messiah_node->obj) return FALSE;

  // Get the data we need from the manager
  BaseObject* obj = mm->getGeometryFromElement(messiah_node->element);
  if (!obj) return FALSE;

  // Everything below is a recursion over an object hierarchy,
  // flattening it as it goes along. Perhaps there's a better way.

  // Record the points and polygons (I hope this is OK)
  BaseObject* child = obj; // The first time it's not a "child"
  LONG processedPoints = 0;
  while (child)
  {
    LONG pointsAdded = 0;

    // Only process point objects
    if (child->GetLayerType() & L_pointobject)
    {
      Matrix mg = child->GetMg();

      PointObject* pobj = static_cast<PointObject*>(child);
      LONG pointCount = pobj->GetPointCount();
      Vector* points = pobj->GetPoint();
      for (int i = 0; i < pointCount; ++i)
      {
        Vector localPoint = mg * points[i];
        nodeObjectCreatePoint(messiah_node->messiah_object, 
          localPoint.x, localPoint.y, localPoint.z);
      }
      pointsAdded += pointCount;
    }

    // Only process polygon objects
    if (child->GetType() == Opolygon)
    {
      PolygonObject* pobj = static_cast<PolygonObject*>(child);
      LONG polyCount = pobj->GetPolygonCount();
      Polygon* polys = pobj->GetPolygon();
      for (int i = 0; i < polyCount; ++i)
      {
        LONG numPoints = (polys[i].c == polys[i].d) ? 3 : 4;

        // I this gives the right memory structure
        LONG accPoints[4];
        accPoints[0] = polys[i].a + processedPoints;
        accPoints[1] = polys[i].a + processedPoints;
        accPoints[2] = polys[i].a + processedPoints;
        accPoints[3] = polys[i].a + processedPoints;

        nodeObjectCreatePoly(messiah_node->messiah_object, 
		    	numPoints, &accPoints[0], 0, 0);
      }
    }

    processedPoints += pointsAdded;
    child = GetNextHierarchyObject(child, obj);
  }

	//Record a dummy surface for now
  nodeObjectCreateSurface(messiah_node->messiah_object, "Dummy");

  // End the node
	nodeObjectEnd(messiah_node->messiah_object, add_to_hierarchy);

  return TRUE;
}

